;Subroutines

;************************
;*    BALL Subroutine   *
;************************
;This subroutine will animate the ball sprite and
;control where it goes.


BALL SUBROUTINE

	jmp .hit		;go to .hit to see if the ball has hit
				;a wall!

.HITPAD2 lda #$01	;Since the ball has hit pad 2 (front side), then
	sta HITY	;subtract INCSPEED from BALLSPEED and store #$01 
	lda BALLSPEED	;into HITY
	cmp #$01
	beq .back2
	sec
	lda BALLSPEED
	sbc INCSPEED
	sta BALLSPEED
	jmp .back2

.PADDLEH1 ldx #$00		;find out if the ball hits the front of
	lda #$00		;the paddle (first player).
.PADLP1	sec
	lda MOVE
	sbc #$06
	clc
	stx RANGE
	adc RANGE
	cmp MOVEX
	beq .HITPAD1
	inx
	cpx #$18
	bne .PADLP1		;if it did, go to .HITPAD1
	jmp .hit2		;if not, go to .back

.PADDLEH2 ldx #$00		;find out if the ball hits the front of
	lda #$00		;the paddle (second player).
.PADLP2	sec
	lda MOVE3
	sbc #$06
	clc
	stx RANGE
	adc RANGE
	cmp MOVEX
	beq .HITPAD2
	inx
	cpx #$18
	bne .PADLP2		;if it did, go to .HITPAD1
	jmp .hit2		;if not, go to .hit2
	
.back2 	jsr GOTOXY
	jmp .stat

.hit	lda #$34	;is the ball Y cordinate on the same spot as the back of
	cmp MOVEY	;the paddle? (for player 1)  If so, go to
	beq .PADDL1	;.PADDL1
	lda #$3B	;is the ball Y cordinate on the same spot as the front of
	cmp MOVEY	;the paddle? (for player 1)  If so, go to
	beq .PADDLEH1	;.PADDLEH1
	lda #$C4	;is the ball Y cordinate on the same spot as the front of
	cmp MOVEY	;the paddle? (for player 2)  If so, go to
	beq .PADDLEH2	;.PADDLEH2
	lda #$CB	;is the ball Y cordinate on the same spot as the back of
	cmp MOVEY	;the paddle? (for player 1)  If so, go to
	beq .PADDL2	;.PADDL2
	jmp .hit2



.hit2	lda #$00	
	cmp MOVEX	;Has the ball's x cordinate hit 0? If not,
	bne .NADDX	;go to .NADDX
	jsr ADDX
.NADDX	lda LIMITY
	cmp MOVEY	;Has the ball's y cordinate hit 0? If not,
	bne .NADDY	;go to .NADDY
	inc POINT2
	lda #$01
	sta ENSOUND	;Make sound (since the ball hit the wall).
	jsr ADDY
.NADDY	lda LIMIT
	sec
	sbc #$06	
	cmp MOVEX	
	bne .NSUBX
	jsr SUBX
.NSUBX	lda #$D6
	cmp MOVEY	;Has the ball's Y cordinate hit the bottom of 
	bne .NSUBY	;the screen? If not, goto .NSUBX
	inc POINT1
	lda #$01
	sta ENSOUND	;Make sound (since the ball hit the wall).
	jsr SUBY
.NSUBY	jmp .back2	;Has the ball's x cordinate hit the right most
			;part of the screen?  If not, goto .NSUBY

.HITPAD1 lda #$00
	sta HITY	;Since the ball has hit pad 1 (front side), then
	lda BALLSPEED	;subtract INCSPEED from BALLSPEED and store #$01 
	cmp #$01	;into HITY
	beq .back2
	sec		
	lda BALLSPEED
	sbc INCSPEED
	sta BALLSPEED
	jmp .back2

.HITPADT1 lda #$01	;Since the ball has hit pad 1 (back side), then
	sta HITY	;store #$01 into HITY
	jmp .back2
.HITPADT2 lda #$00	;Since the ball has hit pad 2 (back side), then
	sta HITY	;store #$00 into HITY
	jmp .back
.PADDL1 ldx #$00
	lda #$00
.PADL1	sec
	lda MOVE	
	sbc #$06
	clc		;Find out if ball has hit the back of the paddle
	stx RANGE	;(player 1). If so, goto .HITPADT1
	adc RANGE
	cmp MOVEX
	beq .HITPADT1
	inx
	cpx #$18
	bne .PADL1		;otherwise, go to .hit2
	jmp .hit2
.PADDL2 ldx #$00
	lda #$00
.PADL2	sec
	lda MOVE3
	sbc #$06
	clc		;Find out if ball has hit the back of the paddle
	stx RANGE	;(player 2). If so, goto .HITPADT2
	adc RANGE
	cmp MOVEX
	beq .HITPADT2
	inx
	cpx #$18
	bne .PADL2	;otherwise, go to .hit2
	jmp .hit2

.back   jsr GOTOXY	;goto GOTOXY subroutine to check to see
			;if the ball has hit either paddle.


.stat	ldx #$00
	ldy #$00
.speed	lda #$13
	sta $2003
	lda MOVEX	;Put the ball sprite on the screen at the
	sta $2004	;x cordinate MOVEX and the y cordinate MOVEY.
	lda #$10
	sta $2003	;BALLSPEED slows down the process to give a 
	lda MOVEY	;smoothe animation.
	sta $2004
	inx
	cpx BALLSPEED
	bne .speed
	rts

;SMALL SUBROUTINES used in BALL.

ADDX SUBROUTINE
	lda #$00	;Store #$00 into HITX so the ball will move
	sta HITX	;to the right on the screen.  Then continue on...
	rts

ADDY SUBROUTINE  
	lda #$00	;Store #$00 into HITY so the ball will move
	sta HITY	;down on the screen.  Then continue on...
	rts

SUBX SUBROUTINE  
	lda #$01	;Store #$01 into HITX so the ball will move
	sta HITX	;to the left on the screen.  Then continue on...
	rts

SUBY SUBROUTINE
	lda #$01 	;Store #$00 into HITY so the ball will move
	sta HITY	;up on the screen.  Then continue on...
	rts

;**************************
;*    GOTOXY Subroutine   *
;**************************
;This subroutine helps out the BALL
;subroutine by telling it where to
;place the ball.  It uses MOVEX and
;MOVEY as x and y cordinates.

GOTOXY SUBROUTINE

.X	lda #$00		;if HITX is equal to #$00 then goto
	cmp HITX		;.AX
	beq .AX
	lda #$01		;if HITX is equal to #$01 then goto
	cmp HITX		;.SX
	beq .SX

.AX	lda #$00		;if HITY is equal to #$00 then goto
	cmp HITY		;.addXY
	beq .addXY
	lda #$01		;if HITY is equal to #$01 then goto
	cmp HITY		;.aXsY
	beq .aXsY

.SX	lda #$00		;if HITY is equal to #$00 then goto
	cmp HITY		;.aYsX
	beq .aYsX
	lda #$01		;if HITY is equal to #$01 then goto
	cmp HITY		;.subXY
	beq .subXY

.addXY	
	inc MOVEX		;Make the ball go down and to the right.
	inc MOVEY
	jmp .e
.subXY	
	dec MOVEX		;Make the ball go up and to the left.
	dec MOVEY
	jmp .e
.aXsY	
	inc MOVEX		;Make the ball go up and to the right
	dec MOVEY
	jmp .e
.aYsX	
	inc MOVEY		;Make the ball go down and to the left.
	dec MOVEX
	
.e	rts


;***************************
;*    PLAYONE Subroutine   *
;***************************
;This subroutine will animate the paddle.

PLAYONE SUBROUTINE
	
	ldx #$00
	ldy #$00
.speed1	lda #$03
	sta $2003	;Use MOVE as X cordinate (SPRITE 1).
	lda MOVE
	sta $2004
	lda #$07	;Use MOVE2 as X cordinate (SPRITE 2).
	sta $2003
	lda MOVE2
	sta $2004	;I was going to slow it down, but I decided 
	inx		;the BALLSPEED variable did fine for that.
	cpx #$20	;Well, maybe a little bit.
	bne .speed1
	rts

;***************************
;*    PLAYTWO Subroutine   *
;***************************

PLAYTWO SUBROUTINE
	
	ldx #$00
	ldy #$00	;Use MOVE3 as X cordinate (SPRITE 1).
.speed2	lda #$0B
	sta $2003
	lda MOVE3
	sta $2004	;Use MOVE4 as X cordinate (SPRITE 2).
	lda #$0F
	sta $2003
	lda MOVE4
	sta $2004
	inx
	cpx #$20
	bne .speed2
	rts 

;************************
;*    LEFT Subroutine   *
;************************
;Checks with the NES to see if 
;the left button was pressed (for both
;player 1 and 2).

LEFT SUBROUTINE
	
	lda #$01
	sta $4016
	sta $4017
	lda #$00
	sta $4016
	sta $4017
	lda $4016
	lda $4016
	lda $4016
	lda $4016
	lda $4016	;Has a key been pressed?
	lda $4016	;If so, dec MOVE and MOVE2.
	lda $4016	;If not, see if Player 2
	and #$01	;has pressed anything.
	beq .Pl2
	ldx #$01
	stx PLAYER
	dec MOVE
	dec MOVE2
	

.Pl2	lda $4017
	lda $4017	;Has a key been pressed?
	lda $4017	;If so, dec MOVE3 and MOVE4.
	lda $4017	;If not, return to .loop and 
	lda $4017	;continue with the program
	lda $4017
	lda $4017
	and #$01
	beq .Ret
	ldx #$02
	stx PLAYER
	ldx #$00
	dec MOVE3
	dec MOVE4

.Ret rts

;*************************
;*    RIGHT Subroutine   *
;*************************
;Checks with the NES to see if 
;the left button was pressed (for both
;player 1 and 2).

RIGHT SUBROUTINE

	lda #$01
	sta $4016
	sta $4017
	lda #$00
	sta $4016
	sta $4017
	lda $4016	;Has a key been pressed?
	lda $4016	;If so, inc MOVE and MOVE2.
	lda $4016	;If not, see if Player 2
	lda $4016	;has pressed anything.
	lda $4016
	lda $4016
	lda $4016
	lda $4016
	and #$01
	beq .Plr2
	ldx #$01
	stx PLAYER
	ldx #$00
	inc MOVE
	inc MOVE2

.Plr2	lda $4017
	lda $4017
	lda $4017
	lda $4017
	lda $4017	;Has a key been pressed?
	lda $4017	;If so, inc MOVE3 and MOVE4.
	lda $4017	;If not, go back to .Loop and
	lda $4017	;continue on with the program.
	and #$01
	beq .Re
	ldx #$02
	stx PLAYER
	ldx #$00
	inc MOVE3
	inc MOVE4
.Re rts	

;*************************
;*    SOUND Subroutine   *
;*************************

SOUND SUBROUTINE

	lda #$0F
	sta $4015
	lda #$0F
	sta $400C		;Load explosive like sound.
	lda #$F4
	sta $400E
	lda #$FD
	sta $400E
	
	rts

ENBSOUND SUBROUTINE
	
	lda ENSOUND
	cmp #$01
	bne .begone		;If ENSOUND is one, make an 
	jsr SOUND		;explosive sound.
	inc LOOPS
	lda LOOPS
	cmp #$08		;this makes the sound last longer.
	bne .begone
	lda #$00
	sta LOOPS
	sta ENSOUND
.begone rts

;END OF SUBROUTINE FILE!

	